export interface IAPIParams {
    APIReq: any;
    APIUrl: string;
}
export interface IGenericAPIHookProps<IOutputRes, IAPIRes> extends IAPIParams {
    defaultCall?: boolean;
    formatResponse?: (data: IAPIRes) => IOutputRes;
}
export interface IHook<IResponse, IVariables = any> {
    data: IResponse | undefined;
    fetch: (params?: IVariables) => Promise<IResponse>;
    loading: boolean;
}
/**
 * General Hook structure for API Call.
 * @param defaultCall
 * @param APIUrl
 * @param APIReq
 * @param props
 */
export declare const useGenericAPIHook: <IOutputRes, IAPIRes, IFormData = any>({ defaultCall, APIUrl, APIReq, ...props }: IGenericAPIHookProps<IOutputRes, IAPIRes>) => {
    data: IOutputRes | undefined;
    fetch: (formData?: IFormData | undefined) => Promise<IOutputRes | undefined>;
    loading: boolean;
    errors: string[] | null;
};
